"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:libview2' }"

LibraryDefinition subclass:#stx_libview2
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects *'
!

!stx_libview2 class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Build-Information for creation of the st/x standard library: stx_libview2.
    This library contains additional graphics-interfacing components and infrastructure.
"
! !

!stx_libview2 class methodsFor:'description'!

extensionMethodNames
    ^ #(
    )
! !

!stx_libview2 class methodsFor:'description - compilation'!

additionalDefinitions_make_dot_proto
    ^ '
NT_ADDITIONAL_DEFS::
        @-echo "LIBJPEG_DIR=$$(TOP)\\support\\libjpeg-6a"
        @-echo "LIBJPEG=$$(LIBJPEG_DIR)\libjpeg.lib"
        @-echo "CLOCAL_INCL=-I$$(LIBJPEG_DIR)"
        @-echo "LOCALLIBS=$$(LIBJPEG)"

NT_ADDITIONAL_RULES::
        @-echo "ALL:: $$(LIBJPEG)"
        @-echo
        @-echo "$$(LIBJPEG):
        @-echo "#cd $$(LIBJPEG_DIR)" | tr "#" "\\011"
        @-echo "#make.exe -f makefile.bcc32" | tr "#" "\\011"
        @-echo "#cd $$(TOP)\libview2" | tr ''#'' "\\011"
'

    "Created: / 22-08-2006 / 23:50:57 / cg"
!

additionalDefinitions_nt_dot_mak
    ^ '
# see stdHeader_nt for LIBVIEW2_BASE
# LIBVIEW2_BASE   =0x61800000
LIB_BASE_LD_ARG=-b:$(LIBVIEW2_BASE)

LIBJPEG_DIR=$(TOP)\support\libjpeg-6a
LIBJPEG=$(LIBJPEG_DIR)\libjpeg.lib
CLOCAL_INCL=-I"$(LIBJPEG_DIR)"
LOCALLIBS=$(LIBJPEG)
'

    "Created: / 22-08-2006 / 23:58:05 / cg"
!

additionalRules_make_dot_proto
    ^ '
#
# prelink JPEGReader.o with libjpeg
#
JPEGReader: $(LIBJPEG)
        @$(MAKE) JPEGReader.$(O) \
                CC="$(LIBJPEG_CC)" \
                OPT="$(LIBJPEG_OPT)" \
                LOCALDEFS="-I$(LIBJPEG_DIR)" \
                LIBNAME="$(LIBNAME)" \
                STCOPT="$(STCOPT)" \
                STCLOCALOPT="$(STCLOCALOPT)" \
                CCLOCALOPT="$(CCLOCALOPT)" \
                LINKOBJRULE="$(LINKOBJRULE)"
        @if [ "$(NO_PRELINK_LIBJPEG)" = "" ]; then \
            mv JPEGReader.$(O) __JPEGReader.$(O); \
            echo; \
            echo "prelinking JPEGReader with libjpg ..."; \
            echo; \
            echo ld $(LD_REL_FLAG) -o JPEGReader.$(O) __JPEGReader.$(O) $(LIBJPEG); \
            ld $(LD_REL_FLAG) -o JPEGReader.$(O) __JPEGReader.$(O) $(LIBJPEG); \
            rm -f __JPEGReader.$(O); \
            echo; \
        fi

$(LIBJPEG)::
        @-echo
        @-echo "making libjpg support library ..."
        @-echo
        -(cd $(LIBJPEG_DIR) ; $(MAKE) libjpeg.a CC="$(LIBJPEG_CC)" OPT="$(LIBJPEG_OPT)" CFLAGS="$(LIBJPEG_OPT) $(CCCONFOPT)")
        @-echo

Makefiles::
        -( cd $(LIBJPEG_DIR) ; configure )

additionalMakefiles::
        -( cd $(LIBJPEG_DIR) ; configure ) 
'

    "Created: / 22-08-2006 / 23:58:51 / cg"
!

additionalRules_nt_dot_mak
    ^ '
$(LIBJPEG):
        cd $(LIBJPEG_DIR)
        bmake
        cd ..\..\libview2

$(OUTDIR)JPEGReader.$(O):: $(LIBJPEG_DIR)\jconfig.h

$(LIBJPEG_DIR)\jconfig.h: $(LIBJPEG)
'

    "Created: / 22-08-2006 / 23:58:29 / cg"
!

additionalTargets_make_dot_proto
    "additional targets to be added to the make.proto file."

    ^ 'JPEGReader'

    "Created: / 22-08-2006 / 23:54:37 / cg"
!

additionalTargets_nt_dot_mak
    "additional targets to be added to the nt.mak file."

    ^ '$(LIBJPEG)'

    "Created: / 23-08-2006 / 00:01:19 / cg"
!

stcOptimizationOptions
    ^ '+optspace2 -warnNonStandard'

    "Created: / 23-08-2006 / 11:27:11 / cg"
! !

!stx_libview2 class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
	"/ <className> or (<className> attributes...)
	('AVIReader' #autoload)
	'ActiveHelp'
	'ActiveHelpView'
	'AlignmentOrigin'
	('ApplicationController' #autoload)
	'ApplicationModel'
	'ApplicationSubView'
	'ApplicationWindow'
	'AspectAdaptor'
	('BlitImageReader' #autoload)
	'BlockValue'
	('BorderedWrapper' #autoload)
	('BoundedWrapper' #autoload)
	'BufferedValueHolder'
	'ColorValue'
	('CompositePart' #autoload)
	('CompositeTransform' #autoload)
	('ConvertedValue' #autoload)
	('DependentPart' #autoload)
	'DisplayObject'
	('DisplayTransform' #autoload)
	'DragAndDropManager'
	'DragHandler'
	'DropContext'
	'DropObject'
	'DropSource'
	'DropTarget'
	'EventListener'
	'ExternalTopView'
	('FLIReader' #autoload)
	('FaceReader' #autoload)
	('FillingWrapper' #autoload)
	'FlyByHelp'
	'GIFReader'
	('GeometricWrapper' #autoload)
	('HersheyFont' #autoload)
	'Icon'
	('ImageFrame' #autoload)
	('ImageSequence' #autoload)
	'IndirectValue'
	'InputView'
	('Insets' #autoload)
	('IrisRGBReader' #autoload)
	'JPEGReader'
	'KeyboardProcessor'
	'Layout'
	'LayoutFrame'
	'LayoutOrigin'
	('LayoutWrapper' #autoload)
	'MIMETypeIconLibrary'
	'MIMETypes'
	('MatrixTransform2x3' #autoload)
	'Menu'
	'MenuItem'
	'Model'
	'MultiImage'
	('PBMReader' #autoload)
	('PCXReader' #autoload)
	('PICTReader' #autoload)
	('PNGReader' #autoload)
	'Plug'
	'PluggableAdaptor'
	('PluggableView' #autoload)
	'PopUpBanner'
	'PrintConverter'
	'PrinterContext'
	'PropertyListDictionary'
	'ProtocolAdaptor'
	('RIFFReader' #autoload)
	'RangeAdaptor'
	'ResourceRetriever'
	'ResourceSpecEditor'
	('ST80FormReader' #autoload)
	('ScreenLock' #autoload)
	'SimpleDialog'
	'StandardSystemController'
	('StrokingWrapper' #autoload)
	('SunRasterReader' #autoload)
	'TIFFReader'
	('TargaReader' #autoload)
	'ToolApplicationModel'
	('TranslatingWrapper' #autoload)
	'TransparentBox'
	'TriggerValue'
	'TypeConverter'
	'UIBuilder'
	'ValueHolder'
	'ValueHolderWithWeakDependents'
	'ValueModel'
	('ViewForwardingController' #autoload)
	('VisualComponent' #autoload)
	('VisualPart' #autoload)
	'VisualRegion'
	'WindowBuilder'
	('WindowsIconReader' #autoload)
	('Wrapper' #autoload)
	'XBMReader'
	'XPMReader'
	('XWDReader' #autoload)
	'stx_libview2'
    )
! !

!stx_libview2 class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Additional Graphic Interfacing'
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2006\nCopyright eXept Software AG 1998-2006'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_libview2 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview2/stx_libview2.st,v 1.12 2006-09-14 08:59:12 cg Exp $'
! !
